format PE64 GUI

WINDOW_HEIGHT equ 32		;   DLU
TIMER_ID equ 123124		; ID 
COLOR_ACTIVE equ 0xC000AF70	;    ARGB
COLOR_INACTIVE equ 0x20007F30	;    ARGB

;  GDI+   
macro gdip_invoke proc, [arg] {
common
    invoke proc, arg
    .if eax
	jmp .error_handler
    .endif
}

;  API    BOOL 
macro bool_invoke proc, [arg] {
common
    invoke proc, arg
    .if ~eax
	jmp .error_handler
    .endif
}

entry main	;  

include 'win64wx.inc'

section '.idata' import data readable writeable

library kernel32, 'kernel32.dll', \
	gdi32, 'gdi32.dll', \
	user32, 'user32.dll', \
	gdiplus, 'gdiplus.dll'

import kernel32, \
       GetLocalTime, 'GetLocalTime', \
       ExitProcess, 'ExitProcess'

import gdi32, \
       CreateCompatibleBitmap, 'CreateCompatibleBitmap', \
       CreateCompatibleDC, 'CreateCompatibleDC', \
       DeleteDC, 'DeleteDC', \
       DeleteObject, 'DeleteObject', \
       SelectObject, 'SelectObject'

import user32, \
       DialogBoxIndirectParam, 'DialogBoxIndirectParamW', \
       EndDialog, 'EndDialog', \
       GetClientRect, 'GetClientRect', \
       SetTimer, 'SetTimer', \
       UpdateLayeredWindow, 'UpdateLayeredWindow', \
       GetDC, 'GetDC', \
       ReleaseDC, 'ReleaseDC', \
       ReleaseCapture, 'ReleaseCapture', \
       SendMessage, 'SendMessageW', \
       SetWindowPos, 'SetWindowPos'

import gdiplus, \
       GdiplusStartup, 'GdiplusStartup', \
       GdiplusShutdown, 'GdiplusShutdown', \
       GdipSetSmoothingMode, 'GdipSetSmoothingMode', \
       GdipDeleteGraphics, 'GdipDeleteGraphics', \
       GdipCreateFromHDC, 'GdipCreateFromHDC', \
       GdipGraphicsClear, 'GdipGraphicsClear', \
       GdipCreateSolidFill, 'GdipCreateSolidFill', \
       GdipDeleteBrush, 'GdipDeleteBrush', \
       GdipFillEllipse, 'GdipFillEllipse', \
       GdipResetWorldTransform, 'GdipResetWorldTransform', \
       GdipTranslateWorldTransform, 'GdipTranslateWorldTransform', \
       GdipScaleWorldTransform, 'GdipScaleWorldTransform', \
       GdipRotateWorldTransform, 'GdipRotateWorldTransform', \
       GdipFillPolygon, 'GdipFillPolygon', \
       GdipSetSolidFillColor, 'GdipSetSolidFillColor'

section '.data' data readable writable

hGdipToken dq 0 ; GDI+ 
hBitmap dq 0	;  GDI 
hGraphics dq 0	; GDI+   
hBrush dq 0	; GDI+ 
hDC dq 0	;  GDI 
hOldBmp dq 0	;    
bBlink db 0	;    
fSegSize dd ?	;   float
rcWindow RECT ? ;  

section '.text' code readable executable

;   
g_dlg_template:
dd DS_CENTER or WS_POPUP
dd WS_EX_LAYERED
dw 0, 0, 0, WINDOW_HEIGHT * 385 / 100, WINDOW_HEIGHT, 0, 0
du 'Clock', 0

; GpInput 
g_gdip_input:
dd 1
dq 0
dd 0
dd 0

;   0-9 (   ):
;
;   5
;   -
; 3|4|1
;   -
; 2|6|0
;   _

g_segments:
db 0x6F, 0x03, 0x76, 0x73, 0x1b, 0x79, 0x7d, 0x23, 0x7F, 0x7B

;  
;  ----------
; /	     \
; \	     /
;  ----------
g_segment_points:
dd 0.1, 0.1, 0.2, 0.0, 0.8, 0.0, 0.9, 0.1, 0.8, 0.2, 0.2, 0.2, 0.1, 0.1

;  
g_segments_pos:
dd 0.0, 1.3, 3.0, 4.3, 6.0, 7.3

;  
proc draw_seg, x:DWORD, y:DWORD, h:DWORD

    mov [x], ecx
    mov [y], edx
    mov [h], r8d

    ;     
    gdip_invoke GdipResetWorldTransform, [hGraphics]
    gdip_invoke GdipScaleWorldTransform, [hGraphics], float [fSegSize], float [fSegSize], 0

    .if ~[h]

	;    -      
	mov eax, 0.2
	movd xmm1, eax
	addss xmm1, [x]
	mov eax, 0.1
	movd xmm2, eax
	addss xmm2, [y]

	gdip_invoke GdipTranslateWorldTransform, [hGraphics], rdx, r8, 0
	gdip_invoke GdipRotateWorldTransform, [hGraphics], float dword 90.0, 0

    .else

	mov eax, 0.1
	movd xmm1, eax
	addss xmm1, [x]

	gdip_invoke GdipTranslateWorldTransform, [hGraphics], rdx, float [y], 0

    .endif

    gdip_invoke GdipFillPolygon, [hGraphics], [hBrush], g_segment_points, 7, 0

.error_handler:

    ret

endp

;  
proc draw_dig uses rsi rbx, val:DWORD, pos:DWORD
    locals
	fXMM6 rb 16
	fXMM7 rb 16
    endl

    movdqu xword [fXMM6], xmm6
    movdqu xword [fXMM7], xmm7

    ;      
    movss xmm6, [g_segments_pos + edx * 4]
    mov eax, 1.0
    movd xmm7, eax
    addss xmm7, xmm6

    ;   
    xor esi, esi
    movzx ebx, byte [g_segments + ecx]

    .repeat

	;     CF
	shr ebx, 1

	.if CARRY?
	    gdip_invoke GdipSetSolidFillColor, [hBrush], COLOR_ACTIVE
	.else
	    gdip_invoke GdipSetSolidFillColor, [hBrush], COLOR_INACTIVE
	.endif

	mov r8d, esi
	and r8d, 4

	.if esi < 2
	    movd ecx, xmm7
	.else
	    movd ecx, xmm6
	.endif

	.if esi = 6
	    mov edx, 2.0
	.else
	    test esi, 1
	    .if ZERO?
		mov edx, 1.0
	    .else
		mov edx, 0.0
	    .endif
	.endif

	stdcall draw_seg

	inc esi

    .until esi = 7

.error_handler:
.exit_proc:

    movdqu xmm6, xword [fXMM6]
    movdqu xmm7, xword [fXMM7]

    ret

endp

;   
proc dlg_proc uses rdi rbx, hWnd, uMsg, wParam, lParam
    locals
	tTime SYSTEMTIME
	tPT POINT
	dwBF dd ?
	hDCTemp dq ?
    endl

    mov [hWnd], rcx

    .if rdx = WM_TIMER & r8 = TIMER_ID

	invoke GetLocalTime, addr tTime
	gdip_invoke GdipGraphicsClear, [hGraphics], 0x01000000

	lea rdi, [tTime.wHour]
	xor ebx, ebx

	.repeat

	    mov ax, [rdi]
	    mov cl, 10
	    div cl
	    mov [rdi], ax
	    and eax, 0x0ff

	    stdcall draw_dig, eax, ebx
	    inc ebx

	    mov ax, [rdi]
	    shr eax, 8

	    stdcall draw_dig, eax, ebx

	    add rdi, 2
	    inc ebx

	.until ebx = 6

	xor [bBlink], 1

	.if ZERO?
	    gdip_invoke GdipSetSolidFillColor, [hBrush], COLOR_INACTIVE
	.else
	    gdip_invoke GdipSetSolidFillColor, [hBrush], COLOR_ACTIVE
	.endif

	;  
	gdip_invoke GdipResetWorldTransform, [hGraphics]
	gdip_invoke GdipScaleWorldTransform, [hGraphics], float [fSegSize], float [fSegSize], 0
	gdip_invoke GdipFillEllipse, [hGraphics], [hBrush], float dword 2.65, float dword 0.7, float dword 0.2, float dword 0.2
	gdip_invoke GdipFillEllipse, [hGraphics], [hBrush], float dword 2.65, float dword 1.3, float dword 0.2, float dword 0.2
	gdip_invoke GdipFillEllipse, [hGraphics], [hBrush], float dword 5.65, float dword 0.7, float dword 0.2, float dword 0.2
	gdip_invoke GdipFillEllipse, [hGraphics], [hBrush], float dword 5.65, float dword 1.3, float dword 0.2, float dword 0.2

	mov qword [tPT], 0
	mov [dwBF], 0x01ff0000	  ; BLENDFUNCTION SRC_ALPHA

	bool_invoke UpdateLayeredWindow, [hWnd], 0, 0, rcWindow.right, [hDC], addr tPT, 0, addr dwBF, ULW_ALPHA
	bool_invoke SetWindowPos, [hWnd], HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOREDRAW

    .elseif rdx = WM_LBUTTONDOWN

	bool_invoke ReleaseCapture
	invoke SendMessage, [hWnd], WM_NCLBUTTONDOWN, 2, 0

    .elseif rdx = WM_CLOSE
	jmp .destroy_dialog
    .elseif rdx = WM_INITDIALOG

	bool_invoke GetClientRect, [hWnd], rcWindow

	cvtsi2ss xmm0, [rcWindow.bottom]
	mov eax, 0.45
	movd xmm1, eax
	mulss xmm0, xmm1
	movss [fSegSize], xmm0

	invoke GetDC, 0

	.if ~rax
	    jmp .destroy_dialog
.release_dc_and_destroy:
	    invoke ReleaseDC, [hDCTemp], 0
	    jmp .destroy_dialog
	.else

	    mov [hDCTemp], rax
	    invoke CreateCompatibleDC, rax

	    .if ~rax
		jmp .release_dc_and_destroy
	    .else

		mov [hDC], rax
		invoke CreateCompatibleBitmap, [hDCTemp], [rcWindow.right], [rcWindow.bottom]

		.if ~rax
		    jmp .release_dc_and_destroy
		.else
		    mov [hBitmap], rax
		.endif

		invoke SelectObject, [hDC], rax

		.if ~rax
		    jmp .release_dc_and_destroy
		.endif

	    .endif

	    invoke ReleaseDC, [hDCTemp], 0

	.endif

	gdip_invoke GdipCreateFromHDC, [hDC], hGraphics
	gdip_invoke GdipSetSmoothingMode, [hGraphics], 4
	gdip_invoke GdipCreateSolidFill, 0, hBrush

	bool_invoke SetTimer, [hWnd], TIMER_ID, 500, 0

    .elseif rdx = WM_LBUTTONDBLCLK

.destroy_dialog:
.error_handler:

	invoke EndDialog, [hWnd], 0

    .endif

    xor eax, eax

    ret

endp

proc main

    gdip_invoke GdiplusStartup, hGdipToken, g_gdip_input, 0

    invoke DialogBoxIndirectParam, 0, g_dlg_template, 0, dlg_proc, 0

.error_handler:

    .if [hBrush]
	invoke GdipDeleteBrush, [hBrush]
    .endif

    .if [hDC]
	invoke SelectObject, [hDC], [hOldBmp]
	invoke DeleteDC, [hDC]
    .endif

    .if [hGraphics]
	invoke GdipDeleteGraphics, [hGraphics]
    .endif

    .if [hBitmap]
	invoke DeleteObject, [hBitmap]
    .endif

    .if [hGdipToken]
	invoke GdiplusShutdown, [hGdipToken]
    .endif

    invoke ExitProcess, 0

endp